package processing;

public interface Processor {
	/**
	 * Metoda suca do zlecania zada
	 * 
	 * @param task - tekst reprezentujcy zadanie
	 * @param sl   - suchacz, ktry bdzie informowany o statusie przetwarzania
	 * @return - warto logiczn mwic o tym, czy zadanie przyjto do
	 *         przetwarzania (nie mona zleci kolejnych zada dopki biece
	 *         zadanie si nie zakoczyo i nie zosta pobrany wynik przetwarzania
	 */
	boolean submitTask(String task, StatusListener sl);

	/**
	 * Metoda suca do pobierania informacji o algorytmie przetwarzania
	 * 
	 * @return - informacja o algorytmie przetwarzania (czytelna dla czowieka)
	 */
	String getInfo();

	/**
	 * Metoda suca do pobierania wyniku przetwarzania
	 * 
	 * @return - tekst reprezentujcy wynik przetwarzania
	 */
	String getResult();
}
